//+------------------------------------------------------------------+
//|                                 IFM.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| IFM MNL_TRO_MODIFIED_VERSION                                |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property indicator_minimum 0
#property indicator_buffers 8

#property indicator_color1  Black
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_color4  Blue
#property indicator_color5  Yellow
#property indicator_color6  Orange

#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//+------------------------------------------------------------------+

extern bool Show.Legend  = true ;
extern bool Sound.Alert = true ;
extern bool Show.Message = true ;

extern int MAPeriod = 14 ;

extern int myCorner= 1;
extern int x.offset= 80 ; 
extern int y.offset= 10 ; 
extern int HistoWidth= 2 ;      

extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 16 ;

extern color colorAVG        =  Orange ;

extern color colorMFIupVOLup = Lime ;
extern color colorMFIupVOLdn = Blue ;

extern color colorMFIdnVOLup = Yellow ;
extern color colorMFIdnVOLdn = Red ;

//extern color colorxUp =  Blue ;
extern color colorEq  =  DimGray ;
//extern color colorxDn =  Magenta ;


//+------------------------------------------------------------------+
 
//---- indicator buffers

double v4[];
double ExtMFIBuffer[];
double ExtMFIUpVUpBuffer[];
double ExtMFIDownVDownBuffer[];
double ExtMFIUpVDownBuffer[];
double ExtMFIDownVUpBuffer[];
 

//+------------------------------------------------------------------+
int    digits2, digits, period, win , xInc, yInc, xPos, yPos  ; 
string short_name;
 
string symbol, tChartPeriod, tAlert, tObjName06 ; 
double   point, tempv ;    
color colorPrice ;
datetime Trigger ;
 
 
 
//+------------------------------------------------------------------+
string Arrow , TAG, message ;
int    redbarnum= -1 ,bluebarnum= -1 ,yellowbarnum= -1 ,limebarnum= -1   ;
int    red[],blue[],yellow[],lime[], xlime ;



//+------------------------------------------------------------------+


int init()
  {
   Arrow        =  CharToStr(108) ;  
   period       =  Period() ;  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
    
//---- indicator buffers mapping

   SetIndexBuffer(0,ExtMFIBuffer);       
   SetIndexBuffer(1,ExtMFIUpVUpBuffer);
   SetIndexBuffer(2,ExtMFIDownVDownBuffer);
   SetIndexBuffer(3,ExtMFIUpVDownBuffer);
   SetIndexBuffer(4,ExtMFIDownVUpBuffer);
   SetIndexBuffer(5,v4);
   
   
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, HistoWidth, colorMFIupVOLup);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, HistoWidth, colorMFIdnVOLdn);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, HistoWidth, colorMFIupVOLdn);
   SetIndexStyle(4,DRAW_HISTOGRAM, 0, HistoWidth, colorMFIdnVOLup);  
   SetIndexStyle(5,DRAW_LINE, 0, 1, colorAVG );    
   
   
//---- name for DataWindow and indicator subwindow label
 
   SetIndexLabel(0,"IFM");      
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,"AVG");   
   
//---- sets drawing line empty value
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);       
   SetIndexEmptyValue(3, 0.0);
   SetIndexEmptyValue(4, 0.0);   
   SetIndexEmptyValue(5, 0.0);       
//---- initialization done
      
       TAG = "ifmmnl" ;
      short_name = "ifmmnl_TRO_MODIFIED" ; 
      IndicatorShortName (short_name);
      
      tObjName06 = short_name + "06" ; 
      deinit() ;
      
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
       
   ObDeleteObjectsByPrefix("ifmmnl"); 
   
   TRO() ;   
   return(0);
  }  
//+------------------------------------------------------------------+
//| Indice de Facilitacin de Mercado                                     |
//+------------------------------------------------------------------+
int start()
  {
  
   win =    WindowFind(short_name);
     
   int  i,nLimit,nCountedBars;
   bool bMfiUp=true,bVolUp=true;
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted
   if(nCountedBars>0) nCountedBars--;
   nLimit=Bars-nCountedBars;
//---- Market Facilitation Index calculation


   
   for(i=0; i<nLimit; i++)
   {
         tempv = 0.0 ;
      
      if(CompareDouble(Volume[i],0.0))
        {
         Print(Volume[i]);
         if(i==Bars-1) ExtMFIBuffer[i]=0.0;
         else ExtMFIBuffer[i]=ExtMFIBuffer[i+1];
        }
      else ExtMFIBuffer[i]=(High[i]-Low[i])/(Volume[i]*Point);

   }
   
   for(int n=0; n<nLimit; n++)
   {                 
        v4[n] = iMAOnArray(ExtMFIBuffer,0,MAPeriod,0,MODE_SMA,n) ;
   } 
                
   
   
//---- upanddown flags setting
   if(nCountedBars>1)
     {
      //---- analyze previous bar before recounted bar
      i=nLimit+1;
      if(ExtMFIUpVUpBuffer[i]!=0.0)
        {
         bMfiUp=true;
         bVolUp=true;
        }
      if(ExtMFIDownVDownBuffer[i]!=0.0)
        {
         bMfiUp=false;
         bVolUp=false;
        }
      if(ExtMFIUpVDownBuffer[i]!=0.0)
        {
         bMfiUp=true;
         bVolUp=false;
        }
      if(ExtMFIDownVUpBuffer[i]!=0.0)
        {
         bMfiUp=false;
         bVolUp=true;
        }
     }
//---- dispatch values between 4 buffers

   for(i=nLimit-1; i>=0; i--)
     {
               blue[i]    = 0;
               red[i]     = 0;
               lime[i]    = 0;
               yellow[i]  = 0;
               
      if(i<Bars-1)
        {
         if(ExtMFIBuffer[i]>ExtMFIBuffer[i+1]) bMfiUp=true;
         if(ExtMFIBuffer[i]<ExtMFIBuffer[i+1]) bMfiUp=false;
         if(Volume[i]>Volume[i+1])             bVolUp=true;
         if(Volume[i]<Volume[i+1])             bVolUp=false;
        }
     if(bMfiUp && bVolUp)
       {
        ExtMFIUpVUpBuffer[i]=ExtMFIBuffer[i];
        ExtMFIDownVDownBuffer[i]=0.0;
        ExtMFIUpVDownBuffer[i]=0.0;
        ExtMFIDownVUpBuffer[i]=0.0;
        limebarnum = i ;
        continue;
       }
     if(!bMfiUp && !bVolUp)
       {
        ExtMFIUpVUpBuffer[i]=0.0;
        ExtMFIDownVDownBuffer[i]=ExtMFIBuffer[i];
        ExtMFIUpVDownBuffer[i]=0.0;
        ExtMFIDownVUpBuffer[i]=0.0;
        redbarnum = i ; 
        continue;         
       }
     if(bMfiUp && !bVolUp)
       {
        ExtMFIUpVUpBuffer[i]=0.0;
        ExtMFIDownVDownBuffer[i]=0.0;
        ExtMFIUpVDownBuffer[i]=ExtMFIBuffer[i];
        ExtMFIDownVUpBuffer[i]=0.0;
        bluebarnum = i ;
        continue;         
       }
     if(!bMfiUp && bVolUp)
       {
        ExtMFIUpVUpBuffer[i]=0.0;
        ExtMFIDownVDownBuffer[i]=0.0;
        ExtMFIUpVDownBuffer[i]=0.0;
        ExtMFIDownVUpBuffer[i]=ExtMFIBuffer[i];   
        yellowbarnum = i ;
        continue;         
       }        
    }                     
//---- done
        
  
//----
   
   if(  Show.Message ) { DoShow() ; }
    
   if(Show.Legend) { DoShowLegend(); }   
       
   WindowRedraw() ;
   
   return(0);
  }
//+------------------------------------------------------------------+
 
bool CompareDouble(double dNumber1, double dNumber2)
  {
   bool bCompare=NormalizeDouble(dNumber1-dNumber2,8) == 0;
   return(bCompare);
  }
//+------------------------------------------------------------------+
 

void DoShow()
{
   
   yInc = myFontSize + 5 ;
   yPos = 0 ;
 
   while(true)
   {  
   message = tChartPeriod + " MFIVol = " + DoubleToStr(ExtMFIBuffer[0],4) + " / Avg = " + DoubleToStr(v4[0],4) ;
   if(ExtMFIDownVDownBuffer[0] != 0.0 ) 
   { 
      colorPrice = colorMFIdnVOLdn ;
      tAlert     = message + " MFI DOWN, VOLUME DOWN " ; 
      break ;
   }

   if(ExtMFIUpVUpBuffer[0] != 0.0 ) 
   { 
      colorPrice = colorMFIupVOLup ;
      tAlert     = message + " MFI UP, VOLUME UP " ; 
      break ;
   }
   
   if(ExtMFIUpVDownBuffer[0] != 0.0 ) 
   { 
      colorPrice = colorMFIupVOLdn ;
      tAlert     = message + " MFI UP, VOLUME DOWN " ; 
      break ;
   } 
       
   if(ExtMFIDownVUpBuffer[0] != 0.0) 
   { 
      colorPrice = colorMFIdnVOLup ;
      tAlert     = tChartPeriod +  " MFI DOWN, VOLUME UP " ; 
      break ;
   }  
           tAlert     = " *** PROGRAM ERROR ***" ;     break ;
 
   } 

   
   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06, tAlert , myFontSize, myFont, colorPrice );  
   ObjectSet(tObjName06, OBJPROP_CORNER, 1);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE,  x.offset); // myCorner
   ObjectSet(tObjName06, OBJPROP_YDISTANCE,  y.offset); //     


}    
      
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+  
void DoShowLegend()
{ 



 

int yInc = 20 ;


   setObject(TAG+"UU","MFI UP/VOLUME UP " ,50,yInc+20,colorMFIupVOLup); setObject(TAG+"CH1",limebarnum ,11,yInc+21,colorMFIupVOLup     ,"Courier New");
     
   setObject(TAG+"UD","MFI UP/VOLUME DN " ,50,yInc+33,colorMFIupVOLdn); setObject(TAG+"NE1",bluebarnum ,11,yInc+34,colorMFIupVOLdn     ,"Courier New");

   setObject(TAG+"DU","MFI DN/VOLUME UP " ,50,yInc+46,colorMFIdnVOLup); setObject(TAG+"LO1",yellowbarnum ,11,yInc+46,colorMFIdnVOLup,"Courier New");
  
   setObject(TAG+"DD","MFI DN/VOLUME DN ",50,yInc+59,colorMFIdnVOLdn); setObject(TAG+"HI1",redbarnum ,11,yInc+59,colorMFIdnVOLdn,"Courier New");

       
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+--------- TRO MODIFICATION ---------------------------------------+   